//
// Title:   CRC32.h
// Created: November 28, 2002
// Authors: PJ Arends, Daniel Cotting
//
// Copyright (c) 2001, 2002, Computer Graphics Lab, ETH Zurich
//
// This file is part of the Pointshop3D system.
// See http://www.pointshop3d.com/ for more information.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free
// Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// Contact info@pointshop3d.com if any conditions of this
// licensing are not clear to you.
//

/****************************************************************************
	CRC32.h : header file for the CRC32 class
	written by PJ Arends
	pja@telus.net

	Adapted to PontShop3D by Daniel Cotting

	based on the CRC-32 code found at
	http://www.createwindow.com/programming/crc32/crcfile.htm

	For updates check http://www3.telus.net/pja/crc32.htm

-----------------------------------------------------------------------------
This code is provided as is, with no warranty as to it's suitability or usefulness
in any application in which it may be used. This code has not been tested for
UNICODE builds, nor has it been tested on a network ( with UNC paths ).

This code may be used in any way you desire. This file may be redistributed by any
means as long as it is not sold for profit, and providing that this notice and the
authors name are included.

If any bugs are found and fixed, a note to the author explaining the problem and
fix would be nice.
-----------------------------------------------------------------------------
****************************************************************************/

#ifndef _CRC_32_H_EA6C0EE0_BC30_11d5_B625_A58C4DF45B22_INCLUDED
#define _CRC_32_H_EA6C0EE0_BC30_11d5_B625_A58C4DF45B22_INCLUDED

/////////////////////////////////////////////////////////////////////////////
// Commented for PointShop3D
/////////////////////////////////////////////////////////////////////////////
// #if _MSC_VER > 1000
// #pragma once
// #endif // _MSC_VER > 1000
// 
// #ifndef _WINDOWS_
// #include <windows.h>
// #endif // _WINDOWS_
// 
// #define WM_CRC_THREAD_DONE WM_APP + 0x2DB1
/////////////////////////////////////////////////////////////////////////////

class CRC32
{

/////////////////////////////////////////////////////////////////////////////
// Commented for PointShop3D
/////////////////////////////////////////////////////////////////////////////
//     typedef struct tag_CRCStruct
//     {
//         CRC32 *pCRC_32;
//         TCHAR FileName[_MAX_PATH];
//         LPBYTE pByte;
//         UINT size;
//         HWND hWnd;
//         HANDLE Thread;
//     } CRCStruct, *LPCRCStruct;
/////////////////////////////////////////////////////////////////////////////

public:
    CRC32();
/////////////////////////////////////////////////////////////////////////////
// Commented for PointShop3D
/////////////////////////////////////////////////////////////////////////////
//    DWORD CalcCRC(LPCTSTR FileName, HWND ProgressWnd = NULL);
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Adapted for PointShop3D
/////////////////////////////////////////////////////////////////////////////
//    DWORD CalcCRC(LPVOID buffer, UINT size, HWND ProgressWnd = NULL);
    unsigned long calcCRC(unsigned char* buffer, unsigned int size);

private:
/////////////////////////////////////////////////////////////////////////////
// Commented for PointShop3D
/////////////////////////////////////////////////////////////////////////////
//    static DWORD WINAPI CRC32ThreadProc(LPVOID lpVoid);
/////////////////////////////////////////////////////////////////////////////
    void calculate (unsigned char* buffer, unsigned int size, unsigned long &crc);
    unsigned long reflect(unsigned long ref, char ch);
    unsigned long table[256];
};

#endif // _CRC_32_H_EA6C0EE0_BC30_11d5_B625_A58C4DF45B22_INCLUDED

/////////////////////////////////////////////////////////////////////////////
//
//  End of CRC32.h
//
/////////////////////////////////////////////////////////////////////////////
